-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Charts - Center Label Customization
To customize the doughnut's center, declare the SVG markup in the centerTemplate. This template accepts the PieChart instance. Use this instance to call PieChart methods. For example, call the getInnerRaduis() method to get the radius of the doughnut hole.
Backend API
$(() => {
const formatNumber = new Intl.NumberFormat('en-US', { maximumFractionDigits: 0 }).format;
const commonSettings = {
innerRadius: 0.65,
resolveLabelOverlapping: 'shift',
sizeGroup: 'piesGroup',
legend: {
visible: false,
},
type: 'doughnut',
series: [{
argumentField: 'commodity',
valueField: 'total',
label: {
visible: true,
connector: {
visible: true,
},
format: 'fixedPoint',
backgroundColor: 'none',
customizeText(e) {
return `${e.argumentText}\n${e.valueText}`;
},
},
}],
centerTemplate(pieChart, container) {
const total = pieChart
.getAllSeries()[0]
.getVisiblePoints()
.reduce((s, p) => s + p.originalValue, 0);
const { country } = pieChart.getAllSeries()[0].getVisiblePoints()[0].data;
const circle = createElement('circle', {
cx: 100,
cy: 100,
fill: '#eee',
r: pieChart.getInnerRadius() - 6,
});
const image = createElement('image', {
x: 70,
y: 58,
width: 60,
height: 40,
href: `../../../../images/flags/${country.replace(/\s/, '').toLowerCase()}.svg`,
});
const text = createText({
x: 100,
y: 120,
fill: '#494949',
'text-anchor': 'middle',
'font-size': 18,
}, [country, formatNumber(total)]);
container.appendChild(circle);
container.appendChild(image);
container.appendChild(text);
},
};
function createElement(type, attributes) {
const element = document.createElementNS('http://www.w3.org/2000/svg', type);
Object.keys(attributes).forEach((attributeName) => {
element.setAttribute(attributeName, attributes[attributeName]);
});
return element;
}
function createText(attributes, contents) {
const text = createElement('text', attributes);
const tspan1 = createElement('tspan', { x: attributes.x, dy: 0 });
tspan1.textContent = contents[0];
const tspan2 = createElement('tspan', { x: attributes.x, dy: 20, 'font-weight': 600 });
tspan2.textContent = contents[1];
text.appendChild(tspan1);
text.appendChild(tspan2);
return text;
}
$('#countries')
.dxPieChart($.extend({}, commonSettings, {
dataSource: {
store: data,
filter: ['country', '=', 'France'],
},
}));
$('#waterLandRatio')
.dxPieChart($.extend({}, commonSettings, {
dataSource: {
store: data,
filter: ['country', '=', 'Germany'],
},
}));
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="long-title"><h3>Energy Production (GWh, 2024)</h3></div>
<div class="pies-container">
<div id="countries"></div>
<div id="waterLandRatio"></div>
</div>
</div>
</body>
</html>
.pies-container {
margin: auto;
width: 800px;
}
.pies-container > div {
width: 400px;
float: left;
margin-top: -50px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
const data = [
{ country: 'France', commodity: 'Nuclear', total: 360000 },
{ country: 'France', commodity: 'Thermal', total: 52000 },
{ country: 'Germany', commodity: 'Thermal', total: 210000 },
{ country: 'France', commodity: 'Wind', total: 50000 },
{ country: 'Germany', commodity: 'Wind', total: 140000 },
{ country: 'France', commodity: 'Solar', total: 23000 },
{ country: 'Germany', commodity: 'Solar', total: 70000 },
{ country: 'Germany', commodity: 'Hydro', total: 20000 },
{ country: 'France', commodity: 'Hydro', total: 65000 },
{ country: 'Germany', commodity: 'Biomass', total: 45000 },
];

-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Charts - Center Label Customization
To customize the doughnut's center, declare the SVG markup in the centerTemplate. This template accepts the PieChart instance. Use this instance to call PieChart methods. For example, call the getInnerRaduis() method to get the radius of the doughnut hole.
Backend API
<template>
<div>
<div class="long-title"><h3>Energy Production (GWh, 2024)</h3></div>
<div class="pies-container">
<DxPieChart
v-for="country in countries"
id="pie-chart"
:key="country"
:data-source="getData(country)"
:inner-radius="0.65"
resolve-label-overlapping="shift"
size-group="piesGroup"
type="doughnut"
center-template="centerTemplate"
>
<DxSeries
argument-field="commodity"
value-field="total"
>
<DxLabel
:visible="true"
:customize-text="customizeLabel"
background-color="none"
format="fixedPoint"
>
<DxConnector :visible="true"/>
</DxLabel>
</DxSeries>
<DxLegend :visible="false"/>
<template #centerTemplate="data">
<CenterTemplate :pie-chart="data.data"/>
</template>
</DxPieChart>
</div>
</div>
</template>
<script setup lang="ts">
import {
DxPieChart, DxSeries, DxLegend, DxLabel, DxConnector,
} from 'devextreme-vue/pie-chart';
import { data } from './data.ts';
import CenterTemplate from './CenterTemplate.vue';
const countries = Array.from(new Set(data.map(({ country }) => country)));
const customizeLabel = ({ argumentText, valueText }: { argumentText: string; valueText: string }) => `${argumentText}\n${valueText}`;
const getData = (country: string) => data.filter((i) => i.country === country);
</script>
<style scoped>
.pies-container {
margin: auto;
width: 800px;
}
.pies-container > div {
width: 400px;
float: left;
margin-top: -50px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
</style>
<template>
<svg>
<circle
:r="(pieChart?.getInnerRadius() || 6 ) - 6"
cx="100"
cy="100"
fill="#eee"
/>
<image
:href="getImagePath(country)"
x="70"
y="58"
width="60"
height="40"
/>
<text
:style="{fontSize: 18, fill: '#494949'}"
text-anchor="middle"
x="100"
y="120"
>
<tspan x="100">{{ country }}</tspan><tspan
:style="{ fontWeight: 600 }"
x="100"
dy="20px"
>{{ calculateTotal(pieChart) }}</tspan>
</text>
</svg>
</template>
<script setup lang="ts">
import { computed } from 'vue';
import { type DxPieChart } from 'devextreme-vue/pie-chart';
type DxPieChartInstance = DxPieChart['instance'];
const props = defineProps<{
pieChart: DxPieChartInstance
}>();
const country = computed(() => props ? props.pieChart
?.getAllSeries()[0]
?.getVisiblePoints()[0]
?.data
?.country as string : '');
const getImagePath = (countryName: string): string => `../../../../images/flags/${countryName.replace(/\s/, '').toLowerCase()}.svg`;
const calculateTotal = (pieChart: DxPieChartInstance): string => {
const points = pieChart?.getAllSeries()[0]?.getVisiblePoints() || [];
return formatNumber(
points.reduce<number>((s: number, p) => {
if (typeof p.originalValue === 'number') {
return s + p.originalValue;
}
return s;
}, 0),
);
};
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const data = [
{ country: 'France', commodity: 'Nuclear', total: 360000 },
{ country: 'France', commodity: 'Thermal', total: 52000 },
{ country: 'Germany', commodity: 'Thermal', total: 210000 },
{ country: 'France', commodity: 'Wind', total: 50000 },
{ country: 'Germany', commodity: 'Wind', total: 140000 },
{ country: 'France', commodity: 'Solar', total: 23000 },
{ country: 'Germany', commodity: 'Solar', total: 70000 },
{ country: 'Germany', commodity: 'Hydro', total: 20000 },
{ country: 'France', commodity: 'Hydro', total: 65000 },
{ country: 'Germany', commodity: 'Biomass', total: 45000 },
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
import React from 'react';
import PieChart, {
Series,
Legend,
Label,
Connector,
} from 'devextreme-react/pie-chart';
import type { PieChartTypes } from 'devextreme-react/pie-chart';
import { data } from './data.ts';
import type { CountryData } from './types.ts';
import CenterTemplate from './CenterTemplate.tsx';
const countries: string[] = Array.from(new Set(data.map((item: CountryData): string => item.country)));
const customizeLabel = (e: PieChartTypes.PointInfo): string => `${e.argumentText}\n${e.valueText}`;
function App() {
const pies = countries.map((country: string) => (
<PieChart
id="pie-chart"
key={country}
dataSource={data.filter((i: CountryData): boolean => i.country === country)}
resolveLabelOverlapping="shift"
sizeGroup="piesGroup"
innerRadius={0.65}
centerRender={CenterTemplate}
type="doughnut"
>
<Series
argumentField="commodity"
valueField="total"
>
<Label visible={true}
format="fixedPoint"
customizeText={customizeLabel}
backgroundColor="none">
<Connector visible={true}></Connector>
</Label>
</Series>
<Legend visible={false}></Legend>
</PieChart>
));
return (
<div>
<div className="long-title"><h3>Energy Production (GWh, 2024)</h3></div>
<div className="pies-container">
{pies}
</div>
</div>
);
}
export default App;
import React from 'react';
import PieChart, {
Series, Legend, Label, Connector,
} from 'devextreme-react/pie-chart';
import { data } from './data.js';
import CenterTemplate from './CenterTemplate.js';
const countries = Array.from(new Set(data.map((item) => item.country)));
const customizeLabel = (e) => `${e.argumentText}\n${e.valueText}`;
function App() {
const pies = countries.map((country) => (
<PieChart
id="pie-chart"
key={country}
dataSource={data.filter((i) => i.country === country)}
resolveLabelOverlapping="shift"
sizeGroup="piesGroup"
innerRadius={0.65}
centerRender={CenterTemplate}
type="doughnut"
>
<Series
argumentField="commodity"
valueField="total"
>
<Label
visible={true}
format="fixedPoint"
customizeText={customizeLabel}
backgroundColor="none"
>
<Connector visible={true}></Connector>
</Label>
</Series>
<Legend visible={false}></Legend>
</PieChart>
));
return (
<div>
<div className="long-title">
<h3>Energy Production (GWh, 2024)</h3>
</div>
<div className="pies-container">{pies}</div>
</div>
);
}
export default App;
import React from 'react';
import type { PieChartRef } from 'devextreme-react/pie-chart';
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
function calculateTotal(pieChart: ReturnType<PieChartRef['instance']>): string {
return formatNumber(pieChart
.getAllSeries()[0]
.getVisiblePoints()
.reduce((s, p): number => s + Number(p.originalValue), 0));
}
function getImagePath(country: string): string {
return `../../../../images/flags/${country.replace(/\s/, '').toLowerCase()}.svg`;
}
export default function TooltipTemplate(pieChart: ReturnType<PieChartRef['instance']>) {
const { country } = pieChart.getAllSeries()[0].getVisiblePoints()[0].data;
return (
<svg>
<circle cx="100" cy="100" r={pieChart.getInnerRadius() - 6} fill="#eee"></circle>
<image href={getImagePath(country)} x="70" y="58" width="60" height="40" />
<text textAnchor="middle" x="100" y="120" style={{ fontSize: 18, fill: '#494949' }}>
<tspan x="100">{country}</tspan>
<tspan x="100" dy="20px" style={{ fontWeight: 600 }}>{
calculateTotal(pieChart)
}</tspan>
</text>
</svg>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { CountryData } from './types.ts';
export const data: CountryData[] = [
{ country: 'France', commodity: 'Nuclear', total: 360000 },
{ country: 'France', commodity: 'Thermal', total: 52000 },
{ country: 'Germany', commodity: 'Thermal', total: 210000 },
{ country: 'France', commodity: 'Wind', total: 50000 },
{ country: 'Germany', commodity: 'Wind', total: 140000 },
{ country: 'France', commodity: 'Solar', total: 23000 },
{ country: 'Germany', commodity: 'Solar', total: 70000 },
{ country: 'Germany', commodity: 'Hydro', total: 20000 },
{ country: 'France', commodity: 'Hydro', total: 65000 },
{ country: 'Germany', commodity: 'Biomass', total: 45000 },
];
export type CountryData = {
country: string;
commodity: string;
total: number;
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
function calculateTotal(pieChart) {
return formatNumber(
pieChart
.getAllSeries()[0]
.getVisiblePoints()
.reduce((s, p) => s + Number(p.originalValue), 0),
);
}
function getImagePath(country) {
return `../../../../images/flags/${country.replace(/\s/, '').toLowerCase()}.svg`;
}
export default function TooltipTemplate(pieChart) {
const { country } = pieChart.getAllSeries()[0].getVisiblePoints()[0].data;
return (
<svg>
<circle
cx="100"
cy="100"
r={pieChart.getInnerRadius() - 6}
fill="#eee"
></circle>
<image
href={getImagePath(country)}
x="70"
y="58"
width="60"
height="40"
/>
<text
textAnchor="middle"
x="100"
y="120"
style={{ fontSize: 18, fill: '#494949' }}
>
<tspan x="100">{country}</tspan>
<tspan
x="100"
dy="20px"
style={{ fontWeight: 600 }}
>
{calculateTotal(pieChart)}
</tspan>
</text>
</svg>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const data = [
{ country: 'France', commodity: 'Nuclear', total: 360000 },
{ country: 'France', commodity: 'Thermal', total: 52000 },
{ country: 'Germany', commodity: 'Thermal', total: 210000 },
{ country: 'France', commodity: 'Wind', total: 50000 },
{ country: 'Germany', commodity: 'Wind', total: 140000 },
{ country: 'France', commodity: 'Solar', total: 23000 },
{ country: 'Germany', commodity: 'Solar', total: 70000 },
{ country: 'Germany', commodity: 'Hydro', total: 20000 },
{ country: 'France', commodity: 'Hydro', total: 65000 },
{ country: 'Germany', commodity: 'Biomass', total: 45000 },
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.pies-container {
margin: auto;
width: 800px;
}
.pies-container > div {
width: 400px;
float: left;
margin-top: -50px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
.dxc-hole-template:focus {
outline: none;
}

Backend API
<div>
<div class="long-title"><h3>Energy Production (GWh, 2024)</h3></div>
<div class="pies-container">
@for(country of countries; track country) {
<dx-pie-chart
class="pie"
sizeGroup="piesGroup"
[dataSource]="service.getData(country)"
[animation]="false"
resolveLabelOverlapping="shift"
type="doughnut"
centerTemplate="centerTemplate"
[innerRadius]="0.65"
>
<dxi-pie-chart-series argumentField="commodity" valueField="total">
<dxo-pie-chart-label
backgroundColor="none"
[visible]="true"
format="fixedPoint"
[customizeText]="customizeLabel"
>
<dxo-pie-chart-connector [visible]="true"></dxo-pie-chart-connector>
</dxo-pie-chart-label>
</dxi-pie-chart-series>
<dxo-pie-chart-legend [visible]="false"> </dxo-pie-chart-legend>
<svg *dxTemplate="let pieChart of 'centerTemplate'">
<circle
cx="100"
cy="100"
[attr.r]="pieChart.getInnerRadius() - 6"
fill="#eee"
></circle>
<image
attr.href="{{ getImagePath(country) }}"
x="70"
y="58"
width="60"
height="40"
/>
<text
class="center-label"
text-anchor="middle"
x="100"
y="120"
fill="#494949"
>
<tspan x="100">{{ country }}</tspan>
<!-- display: inline -->
<tspan class="center-label-total" x="100" dy="20px">{{
calculateTotal(pieChart)
}}</tspan>
</text>
</svg>
</dx-pie-chart>
}
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxPieChartModule } from 'devextreme-angular';
import { DecimalPipe } from '@angular/common';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxPieChartModule,
],
})
export class AppComponent {
service: Service;
countries: Iterable<string>;
pipe = new DecimalPipe('en-US');
constructor(service: Service) {
this.service = service;
this.countries = new Set(service.getData().map((item) => item.country));
}
customizeLabel(e) {
return `${e.argumentText}\n${e.valueText}`;
}
calculateTotal(pieChart) {
const totalValue = pieChart.getAllSeries()[0].getVisiblePoints().reduce((s, p) => s + p.originalValue, 0);
return this.pipe.transform(totalValue, '1.0-0');
}
getImagePath(country) {
return `../../../../images/flags/${country.replace(/\s/, '').toLowerCase()}.svg`;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .pies-container {
margin: auto;
width: 800px;
}
::ng-deep .pies-container > .pie {
width: 400px;
margin-top: -50px;
float: left;
}
::ng-deep .long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
::ng-deep .center-label {
font-size: 18px;
}
::ng-deep .center-label-total {
font-weight: 600;
}
import {
Injectable,
} from '@angular/core';
export class DataItem {
country: string;
commodity: string;
total: number;
}
const data: DataItem[] = [
{ country: 'France', commodity: 'Nuclear', total: 360000 },
{ country: 'France', commodity: 'Thermal', total: 52000 },
{ country: 'Germany', commodity: 'Thermal', total: 210000 },
{ country: 'France', commodity: 'Wind', total: 50000 },
{ country: 'Germany', commodity: 'Wind', total: 140000 },
{ country: 'France', commodity: 'Solar', total: 23000 },
{ country: 'Germany', commodity: 'Solar', total: 70000 },
{ country: 'Germany', commodity: 'Hydro', total: 20000 },
{ country: 'France', commodity: 'Hydro', total: 65000 },
{ country: 'Germany', commodity: 'Biomass', total: 45000 },
];
const cache = {};
@Injectable()
export class Service {
getData(country?: string): DataItem[] {
if (country) {
if (!cache[country]) {
cache[country] = data.filter((item) => item.country === country);
}
return cache[country];
}
return data;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>